<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { postRaw } from "$lib/httpService";
  import { userStore, tokenStore } from "$lib/stores";
  import type { User } from "$lib/types";
  import BaseModal from "./BaseModal.svelte";

  const dispatch = createEventDispatcher();
  let email: string = "";
  let password: string = "";
  let displayName: string = "";
  let organizer: boolean = false;

  async function register() {
    try {
      const response = await postRaw("api/User/register", JSON.stringify({
        email,
        password,
        displayName,
        organizer,
      }));

      let auth;
      if (response.ok && (auth = response.headers.get("Authorization"))) {
        const data: User = await response.json();
        userStore.set(data);
        const authToken = auth.split(" ")[1];
        tokenStore.set(authToken);

        dispatch("close");
      } else {
        console.error("Registration failed:", response);
        alert("Registration failed: " + response.statusText);
      }
    } catch (error) {
      console.error("Registration failed:", error);
      alert("Registration failed: " + error);
    }
  }

  function closeModal() {
    dispatch("close");
  }
</script>

<BaseModal on:close={closeModal}>
  <h2>Register</h2>
  <input id="email" type="email" bind:value={email} placeholder="Email" />
  <input id="password" type="password" bind:value={password} placeholder="Password" />
  <input id="displayName" type="text" bind:value={displayName} placeholder="Display Name" />
  <input id="organizer" type="checkbox" bind:checked={organizer} />
  <label for="organizer">Organizer</label>
  <div>
    <button on:click={register}>Register</button>
    <button on:click={closeModal}>Cancel</button>
  </div>
</BaseModal>
